<template>
    <div class="row" :class="[isSender ? 'justify-end' : ' justify-start']">
        <div
            class="bubble-video q-ma-sm"
            :class="[isSender ? 'justify-end sender' : '']"
            @click.stop="previewMedia"
        >
            <q-img
                fit="contain"
                :src="imageUrl"
                width="250px"
                @error="onError"
            />

            <p v-if="text" class="caption">
                {{ text }}
            </p>

            <span class="time-text helvetica-neue-medium font-10 q-pr-xs">
                {{ time }}
            </span>

            <q-btn
                dense
                text
                flat
                v-if="statusIcon.name"
                @click="resendErrorMessage(statusIcon.name, message.id)"
            >
                <q-icon
                    :name="statusIcon.name"
                    :color="statusIcon.color"
                    size="15px"
                />
            </q-btn>

            <q-btn
                class="btn-play"
                flat
                borderless
                icon="mdi-play"
                rounded
                color="white"
                size="20px"
            />
        </div>
    </div>
</template>

<script lang="ts">
import MessageController from '../../../src/controller/MessageController';
import { defineComponent, ref } from 'vue';
import { Message } from 'src/services/models/Message';
import generateRandomString from 'src/services/helpers/GenerateRandomString';
import { useStore } from 'src/store';

export default defineComponent({
    name: 'BubbleVideo',
    props: {
        message: {
            type: Object as () => Message,
            required: true
        }
    },
    setup(props) {
        const store = useStore();

        const { isSender, height, previewMedia, time, text, statusIcon } =
            MessageController(props.message);

        const imageUrl = ref(props.message.thumbnail?.url ?? '');
        let retryCount = 0;

        const onError = () => {
            if (retryCount < 5) {
                setTimeout(() => {
                    imageUrl.value = `${
                        props.message.thumbnail?.url ?? ''
                    }?i=${generateRandomString(4)}`;
                    retryCount++;
                }, 1000);
            }
        };

        const resendErrorMessage = (statusName: any, id: string) => {
            if (statusName == 'error') {
                store.dispatch('message/resendErrorMessage', id);
            }
        };

        return {
            isSender,
            height,
            previewMedia,
            onError,
            imageUrl,
            time,
            text,
            statusIcon,
            resendErrorMessage
        };
    }
});
</script>
